%define anolis_release 1

Name:           perl-Test-Compile
Version:        3.2.2
Release:        %{anolis_release}%{?dist}
Summary:        Check whether Perl module files compile correctly
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/Test-Compile
Source0:        https://cpan.metacpan.org/authors/id/E/EG/EGILES/Test-Compile-v%{version}.tar.gz
BuildArch:      noarch
BuildRequires:  coreutils
BuildRequires:  make
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(Config)
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
# Run-time
BuildRequires:  perl(Exporter)
BuildRequires:  perl(File::Spec)
BuildRequires:  perl(IPC::Open3)
BuildRequires:  perl(parent)
BuildRequires:  perl(strict)
BuildRequires:  perl(Test::Builder)
BuildRequires:  perl(version)
BuildRequires:  perl(warnings)
# Tests
BuildRequires:  perl(FindBin)
# Test::More version is described in Changes
BuildRequires:  perl(Test::More) >= 0.88
# Optional tests
BuildRequires:  perl(Test::Exception)
BuildRequires:  perl(Test::Warnings)


%{?perl_default_filter}
# Filter modules bundled for tests
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libexecdir}
%global __requires_exclude_from %{?__requires_exclude_from:%__requires_exclude_from|}^%{_libexecdir}/%{name}/lib

%description
Test::Compile lets you check the validity of a Perl module file or Perl script
file, and report its results in standard Test::Simple fashion.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{EVR}
Requires:       perl-Test-Harness
# Optional tests
Requires:       perl(Test::Exception)
Requires:       perl(Test::Warnings)

%description tests
Tests from %{name}. Execute them
with "%{_libexecdir}/%{name}/test".

%prep
%setup -q -n Test-Compile-v%{version}

# Help generators to recognize Perl scripts
for F in t/*.t; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!.*perl\b}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
%{_fixperms} %{buildroot}/*

# Install tests
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}
mkdir -p %{buildroot}%{_libexecdir}/%{name}/lib/Test/Compile
for F in Test/Compile.pm Test/Compile/Internal.pm; do
    ln -s %{perl_vendorlib}/$F %{buildroot}%{_libexecdir}/%{name}/lib/$F
done
# Remove author tests
rm %{buildroot}%{_libexecdir}/%{name}/t/999-*
perl -i -ne 'print $_ unless m{\@INC = grep .* \@INC;}' %{buildroot}%{_libexecdir}/%{name}/t/scripts/messWithLib.pl
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
#!/bin/sh
cd %{_libexecdir}/%{name} && exec prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test

%check
unset AUTHOR_TEST
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
make test

%files
%license LICENSE
%doc Changes README
%{perl_vendorlib}/*
%{_mandir}/man3/*

%files tests
%{_libexecdir}/%{name}

%changelog
* Sat May 6 2023 Funda Wang <fundawang@yeah.net> - 3.2.2-1
- Import package for anolis 23
